package org.apache.abdera.test.ext.opensearch.model;

import static org.junit.Assert.assertTrue;

import java.io.IOException;
import java.io.PrintWriter;
import java.io.StringWriter;
import java.util.List;

import org.apache.abdera.Abdera;
import org.apache.abdera.ext.opensearch.OpenSearchConstants;
import org.apache.abdera.ext.opensearch.model.IntegerElement;
import org.apache.abdera.model.Feed;
import org.apache.abdera.writer.Writer;
import org.apache.abdera.xpath.XPath;
import org.junit.Test;

public class TestSelectNodes {

    @Test
    public void testXPath() throws IOException {
        Feed f = Abdera.getInstance().newFeed();
        IntegerElement ext = f.addExtension(OpenSearchConstants.START_INDEX);
        ext.setValue(101);
        XPath path = Abdera.getNewXPath();
        List result = path.selectNodes("node()", ext);
        assertTrue(result.size() > 0);
    }

    @Test
    public void testJson() throws IOException {
        Abdera abdera = Abdera.getInstance();
        Feed f = abdera.newFeed();
        IntegerElement ext = f.addExtension(OpenSearchConstants.START_INDEX);
        ext.setValue(101);
        Writer json = abdera.getWriterFactory().getWriter("json");

        StringWriter stWriter = new StringWriter();
        PrintWriter pWriter = new PrintWriter(stWriter);
        f.writeTo(json, pWriter);
        assertTrue(stWriter.toString().contains("101"));
        assertTrue(stWriter.toString().contains("os:startIndex"));
    }

}
